close all
%% Operazioni Logiche

A = zeros(100);
A(10:50, 10:50)=1;

B = zeros(100);
B(40:70,40:90)=1;

subplot(3,2,1);
imshow(A,[]);
title('A');

subplot(3,2,2);
imshow(~A,[]);
title('NOT(A)');

subplot(3,2,3);
imshow(B,[]);
title('B');

subplot(3,2,4);
imshow(~B,[]);
title('NOT(B)');

subplot(3,2,5);
imshow(A&B,[]);
title('A&B');

subplot(3,2,6);
imshow(A|B,[]);
title('A|B');


%%
%Regioni Connesse

[imgName, path] = uigetfile('*.jpg;*.bmp;*.png;*.tiff;*.jpeg', 'Pick an image file');
img = imread([path imgName]);

dim = size(size(img));
if dim(2) == 3
    img_gray = rgb2gray(img);
else
    img_gray = img;
end

 

figure;
subplot(1,3,1);
imshow(img);
title('Original Image');

imgBW = im2bw(img_gray);
subplot(1,3,2);
imshow(imgBW);
title('Binary images');
 
Bholes = imfill(imgBW, 'holes');
subplot(1,3,3);
imshow(Bholes);
title('Binary images without holes');

[L, n] = bwlabel(Bholes);
pause


%% Compute the attributes
attr = regionprops(L, 'eccentricity', 'area', 'perimeter');
 
[maxPer idx_Per] = max([attr.Perimeter]);
reg_maxPerim = ismember(L, idx_Per);

RGB = label2rgb(L);
subplot(1,2,1);
imshow(RGB, []);
title('Region labels');

subplot(1,2,2);
imshow(reg_maxPerim, []);
title('Region with max perimeter');